<?php
namespace FM\Service;

use FM\Factory\FuncionariosFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;

class FuncionariosService {

    protected $FuncionariosFactory;
    protected $Environment;
    protected $newCode;

    public function __construct (FuncionariosFactory $FuncionariosFactory, Environment $Environment, NewCode $newCode) {
        $this->FuncionariosFactory  = $FuncionariosFactory;
        $this->Environment                  = $Environment;
        $this->newCode                      = $newCode;
    }

    public function searchShift(){
        $operadores = $this->FuncionariosFactory->searchShift();
        return $operadores;
    }

    public function searchOffice(){
        // regras de negócio
        $operadores = $this->FuncionariosFactory->searchOffice();
        // sempre dar o retorno para que seja retornado para o controller e passado para o frontEnd
        return $operadores;
    }

    public function searchTasks(){
        $operadores = $this->FuncionariosFactory->searchTasks();
        return $operadores;
    }

    public function searchOccupation(){
        $operadores = $this->FuncionariosFactory->searchOccupation();
        return $operadores;
    }

    public function searchSector(){
        $operadores = $this->FuncionariosFactory->searchSector();
        return $operadores;
    }

    public function dataBaseCards($parametro) {
        $param = '';
        $filterName = 'N';
        $filterShift = 'N';

        if ($parametro['InputName'] != '' && $parametro['InputName'] != null){
            $param = " WHERE UPPER(FCM_FUNCIONARIO.NMFUNCIONARIO) LIKE UPPER('%".$parametro['InputName']."%')";
            $filterName = 'S';
        }
        if ($parametro['SelectShift'] != '' && $parametro['SelectShift'] != null) {
            if ($filterName == 'N') {
                $param = " WHERE FCM_FUNCIONARIO.IDTURNOFUNCIONARIO IN (".implode(',', $parametro['SelectShift']).")";
            } else {
                $param = $param." AND FCM_FUNCIONARIO.IDTURNOFUNCIONARIO IN (".implode(',', $parametro['SelectShift']).")";
            }
            $filterShift = 'S';
        }

         if ($parametro['SelectOffice'] != '' && $parametro['SelectOffice'] != null) {
            if (($filterName == 'N') && ($filterShift == 'N')) {
                $param = " WHERE FCM_HABILIDADE.NRHABILIDADE IN (".implode(',', $parametro['SelectOffice']).")";
            } else {
                $param = " AND FCM_HABILIDADE.NRHABILIDADE IN (".implode(',', $parametro['SelectOffice']).")";
            }
            $filterOffice = 'S';
        }

        $operadores = $this->FuncionariosFactory->dataBaseCards($param);
        return $operadores;
    }

    public function dataBaseTaskCards($nrfuncionario){
        $parametros = array(
            "NRFUNCIONARIO" => $nrfuncionario
            );
        $operadores = $this->FuncionariosFactory->dataBaseTaskCards($parametros);
        return $operadores;
    }

    public function dataBaseNewEmployee($nmfuncionario, $nrrgfuncionario, $nrcpffuncionario, $dsemailfuncionario, $nrtelfuncionario, $hrentradapadr, $hrsaidapadr, $idturnofuncionario, $nrorg, $operador, $nrhabilidade) {

        $nrrgfuncionario = str_replace(".", "", $nrrgfuncionario);
        $nrcpffuncionario = str_replace(".", "", $nrcpffuncionario);
        $nrcpffuncionario = str_replace("-", "", $nrcpffuncionario);
        $nrtelfuncionario = str_replace("(", "", $nrtelfuncionario);
        $nrtelfuncionario = str_replace(")", "", $nrtelfuncionario);
        $nrtelfuncionario = str_replace("-", "", $nrtelfuncionario);
        $nrtelfuncionario = str_replace(" ", "", $nrtelfuncionario);

        $nrfuncionario = $this->newCode->getCodeByTableName("FCM_FUNCIONARIO", $nrorg, 1, 10, true);

        $parametros = array(
            "NRFUNCIONARIO"      => $nrfuncionario,
            "NMFUNCIONARIO"      => $nmfuncionario,
            "NRPESSOA"           => null,
            "CDOPERADOR"         => null,
            "NRRGFUNCIONARIO"    => $nrrgfuncionario,
            "NRCPFFUNCIONARIO"   => $nrcpffuncionario,
            "DSEMAILFUNCIONARIO" => $dsemailfuncionario,
            "NRTELFUNCIONARIO"   => $nrtelfuncionario,
            "HRENTRADAPADR"      => $hrentradapadr,
            "HRSAIDAPADR"        => $hrsaidapadr,
            "IDTURNOFUNCIONARIO" => $idturnofuncionario,
            "NRORG"              => $nrorg,
            "OPERADOR"           => $operador
            );


        $this->FuncionariosFactory->newEmployeeDataBase($parametros);

        $nrrelacfunchab = $this->newCode->getCodeByTableName("FCM_RELACFUNCHAB", $nrorg, 1, 10, true);

        $parametros = array(
            "NRRELACFUNCHAB" => $nrrelacfunchab,
            "NRHABILIDADE"   => $nrhabilidade,
            "NRFUNCIONARIO"  => $nrfuncionario,
            "NRORG"          => $nrorg,
            "OPERADOR"       => $operador
            );


        $this->FuncionariosFactory->newOccupationEmployee($parametros);
    }

    public function updateEmployeeDataBase($nmfuncionario, $nrrgfuncionario, $nrcpffuncionario, $dsemailfuncionario, $nrtelfuncionario, $hrentradapadr, $hrsaidapadr, $idturnofuncionario, $nrhabilidade, $nrfuncionario, $nrorg) {

        $nrrgfuncionario = str_replace(".", "", $nrrgfuncionario);
        $nrcpffuncionario = str_replace(".", "", $nrcpffuncionario);
        $nrcpffuncionario = str_replace("-", "", $nrcpffuncionario);
        $nrtelfuncionario = str_replace("(", "", $nrtelfuncionario);
        $nrtelfuncionario = str_replace(")", "", $nrtelfuncionario);
        $nrtelfuncionario = str_replace("-", "", $nrtelfuncionario);
        $nrtelfuncionario = str_replace(" ", "", $nrtelfuncionario);

        $parametros = array(
            "NMFUNCIONARIO"      => $nmfuncionario,
            "NRRGFUNCIONARIO"    => $nrrgfuncionario,
            "NRCPFFUNCIONARIO"   => $nrcpffuncionario,
            "DSEMAILFUNCIONARIO" => $dsemailfuncionario,
            "NRTELFUNCIONARIO"   => $nrtelfuncionario,
            "HRENTRADAPADR"      => $hrentradapadr,
            "HRSAIDAPADR"        => $hrsaidapadr,
            "IDTURNOFUNCIONARIO" => $idturnofuncionario,
            "NRFUNCIONARIO"      => $nrfuncionario,
            "NRORG"              => $nrorg
            );

        $this->FuncionariosFactory->updateEmployeeDataBase($parametros);

        $parametros = array(
            "NRHABILIDADE"   => $nrhabilidade,
            "NRFUNCIONARIO"  => $nrfuncionario,
            "NRORG"          => $nrorg
            );

        $this->FuncionariosFactory->updateOccupationEmployee($parametros);
    }

    public function deleteEmployeeDataBase($nrfuncionario, $nrorg, $nrrelacfunchab) {

        $parametros = array(
            "NRFUNCIONARIO" => $nrfuncionario,
            "NRORG"         => $nrorg
            );

        $this->FuncionariosFactory->deleteEmployeeDataBase($parametros);

         $parametros = array(
            "NRRELACFUNCHAB" => $nrrelacfunchab,
            "NRORG"          => $nrorg
            );

        $this->FuncionariosFactory->deleteOccupationEmployee($parametros);
    }

    public function getInfoEmployee($nrfuncionario, $nrorg, $nrrelacfunchab) {

        $parametros = array(
            "NRFUNCIONARIO" => $nrfuncionario,
            "NRRELACFUNCHAB"=> $nrrelacfunchab,
            "NRORG"         => $nrorg
            );

       $operadores =  $this->FuncionariosFactory->getInfoEmployee($parametros);
       return $operadores;
    }


}
?>